
 /* 変数型の定義 */
typedef enum {
  STP = 0,
  STR,
  ROT,
  VEL
} run_state_t;

typedef struct {
  unsigned char val[7];
} serial_data_t;

typedef struct {
  unsigned char val[6];
} middle_data_t;

typedef struct {
  signed short val[3];
} command_data_t;

/* ピン配置 */
#define PIN_ENC_A_L  2
#define PIN_ENC_B_L  4
#define PIN_ENC_A_R  3
#define PIN_ENC_B_R  7
#define PIN_ENC_A_S  20
#define PIN_ENC_B_S  32
#define PIN_DIR_R    8
#define PIN_PWM_R    9
#define PIN_DIR_L   11
#define PIN_PWM_L   12
#define PIN_DIR_S   42
#define PIN_PWM_S   44
#define PIN_SW      10
#define PIN_BUZ_1   38
#define PIN_BUZ_2   40
#define PIN_BATT    0
#define PIN_PAT     6

/* パラメータ */
// 動作周期 [ms]
#define T_CTRL 10 

// タイヤ半径 [cm] 3.2
#define R_TIRE     4.25
// タイヤ間隔 [cm] 25.0
#define D_TIRE    32.0
// エンコーダ分解能 (A相立上り/立下りを利用するため2倍)
#define ENC_RANGE (13*2) 
// ギア比
#define T_E_RATIO 5.0
#define T_E_RATIO_S 100.0

// Rタイヤに対するLタイヤの回転比
#define L_R_RATIO  0.998


// バッテリ入力の分圧比
#define V_RATIO 0.5 

// BMX055　加速度センサのI2Cアドレス  
#define Addr_Accl 0x19  // (JP1,JP2,JP3 = Openの時)
// BMX055　ジャイロセンサのI2Cアドレス
#define Addr_Gyro 0x69  // (JP1,JP2,JP3 = Openの時)
// BMX055　磁気センサのI2Cアドレス
#define Addr_Mag 0x13   // (JP1,JP2,JP3 = Openの時)

#define MAX_VAL 64  // 0 to 255 for brightness
#define DELAY_TIME 30
#define DELAY_TIME2 20
#define DELAY_TIME3 50
