// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_RGB     Pixels are wired for RGB bitstream
//   NEO_GRB     Pixels are wired for GRB bitstream
//   NEO_KHZ400  400 KHz bitstream (e.g. FLORA pixels)
//   NEO_KHZ800  800 KHz bitstream (e.g. High Density LED strip)


int led_tape(int mode){
            switch(mode){
              case 0:
                //off
                colorWipe3(strip.Color(0, 0, 0), DELAY_TIME3); // Black
                break;
              case 1:
                //warning
                colorWipe(strip.Color(MAX_VAL, 0, 0), DELAY_TIME); // Red
                colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black
                break;
              case 2:
                //shot
                for (int i = 0; i < 10; i++) {
                  colorWipe3(strip.Color(MAX_VAL, 0, 0), DELAY_TIME3); // Red
                  colorWipe3(strip.Color(0, 0, 0), DELAY_TIME3); // Black
                }
                break;
              case 3:
                //over
                colorWipe(strip.Color(0, MAX_VAL, 0), DELAY_TIME); // Green
                colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black
                break;
              case 4:
                //battery
                colorWipe(strip.Color(MAX_VAL, MAX_VAL, 0), DELAY_TIME); // Yellow
                colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black
                break;
              case 5:
                //illumination
                rainbow(DELAY_TIME2);
                break;
              case 6:
                //normal
                colorWipe3(strip.Color(MAX_VAL, 0, 0), DELAY_TIME3); // Red
                break;
              case 7:
                //demo
                led_set();
                break;
            }
}

void led_set() {

  // Some example procedures showing how to display to the pixels:
  //    colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black
  colorWipe(strip.Color(MAX_VAL, 0, 0), DELAY_TIME); // Red
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(MAX_VAL, 0, 0), DELAY_TIME); // Red
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(0, MAX_VAL, 0), DELAY_TIME); // Green
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(0, MAX_VAL, 0), DELAY_TIME); // Green
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(MAX_VAL, MAX_VAL, 0), DELAY_TIME); // Yellow
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(MAX_VAL, MAX_VAL, 0), DELAY_TIME); // Yellow
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(0, 0, MAX_VAL), DELAY_TIME); // Blue
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(0, 0, MAX_VAL), DELAY_TIME); // Blue
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(MAX_VAL, 0, MAX_VAL), DELAY_TIME); // Purple
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(MAX_VAL, 0, MAX_VAL), DELAY_TIME); // Purple
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(0, MAX_VAL, MAX_VAL), DELAY_TIME); // Cyan
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(0, MAX_VAL, MAX_VAL), DELAY_TIME); // Cyan
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe(strip.Color(MAX_VAL, MAX_VAL, MAX_VAL), DELAY_TIME); // White
  colorWipe(strip.Color(0, 0, 0), DELAY_TIME); // Black

  colorWipe2(strip.Color(MAX_VAL, MAX_VAL, MAX_VAL), DELAY_TIME); // White
  colorWipe2(strip.Color(0, 0, 0), DELAY_TIME); // Black

  for (int i = 0; i < 10; i++) {
    colorWipe3(strip.Color(MAX_VAL, 0, 0), DELAY_TIME3); // Red
    colorWipe3(strip.Color(0, 0, 0), DELAY_TIME3); // Black
  }

  for (int i = 0; i < 10; i++) {
    colorWipe3(strip.Color(MAX_VAL, MAX_VAL, 0), DELAY_TIME3); // Yellow
    colorWipe3(strip.Color(0, 0, 0), DELAY_TIME3); // Black
  }

  for (int i = 0; i < 10; i++) {
    colorWipe3(strip.Color(0, MAX_VAL, MAX_VAL), DELAY_TIME3); // Cyan
    colorWipe3(strip.Color(0, 0, 0), DELAY_TIME3); // Black
  }

  //  rainbow(DELAY_TIME2);
  //  rainbowCycle(DELAY_TIME2);
}

// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for (uint16_t i = 0; i < strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}

//test
void colorWipe2(uint32_t c, uint8_t wait) {
  for (uint16_t i = strip.numPixels(); i > 0; i--) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
  strip.setPixelColor(0, c);
  strip.show();
  delay(wait);
}

//test2
void colorWipe3(uint32_t c, uint8_t wait) {
  // for (uint16_t i = strip.numPixels(); i > 0; i--) {
  strip.setPixelColor(0, c);
  strip.setPixelColor(1, c);
  strip.setPixelColor(2, c);
  strip.setPixelColor(3, c);
  strip.setPixelColor(4, c);
  strip.setPixelColor(5, c);
  strip.setPixelColor(6, c);
  strip.setPixelColor(7, c);
  strip.setPixelColor(8, c);
  strip.setPixelColor(9, c);
  strip.setPixelColor(10, c);
  strip.setPixelColor(11, c);
  strip.setPixelColor(12, c);
  strip.setPixelColor(13, c);
  strip.setPixelColor(14, c);
  strip.setPixelColor(15, c);
  strip.setPixelColor(16, c);
  strip.setPixelColor(17, c);
  strip.setPixelColor(18, c);
  strip.setPixelColor(19, c);
  strip.show();
  delay(wait);
  // }
}

//test3
void colorWipe4(uint32_t c, uint8_t wait) {
  // for (uint16_t i = strip.numPixels(); i > 0; i--) {
  strip.setPixelColor(4, c);
  strip.setPixelColor(5, c);
  strip.show();
  delay(wait * 5);
  strip.setPixelColor(3, c);
  strip.setPixelColor(6, c);
  strip.show();
  delay(wait * 4);
  strip.setPixelColor(2, c);
  strip.setPixelColor(7, c);
  strip.show();
  delay(wait * 3);
  strip.setPixelColor(1, c);
  strip.setPixelColor(8, c);
  strip.show();
  delay(wait * 2);
  strip.setPixelColor(0, c);
  strip.setPixelColor(9, c);
  strip.show();
  delay(wait);
  // }
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for (j = 0; j < 256; j++) {
    for (i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for (j = 0; j < 256 * 5; j++) { // 5 cycles of all colors on wheel
    for (i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if (WheelPos < 85) {
    return strip.Color((WheelPos * 3) * MAX_VAL / 255, (255 - WheelPos * 3) * MAX_VAL / 255, 0);
  } else if (WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color((255 - WheelPos * 3) * MAX_VAL / 255, 0, (WheelPos * 3) * MAX_VAL / 255);
  } else {
    WheelPos -= 170;
    return strip.Color(0, (WheelPos * 3) * MAX_VAL / 255, (255 - WheelPos * 3) * MAX_VAL / 255);
  }
}
