#include <stdio.h>
#include <wiringPi.h>
#include <unistd.h>
#include "human.h"
#include "flag.h"
#include "run.h"

// ピン配置
static const int pin_human_f  = 18;
static const int pin_human_l  = 12;
static const int pin_human_r  = 25;
static const int pin_human_b = 26;

/*----------------------IOオープン--------------*/

int human_init(){

	// GPIOデバイスのオープン
	if(wiringPiSetupGpio() != 0){
		printf("failed to open GPIO\n");
		return -1;
	}
    else{
		// ピン設定
		pinMode(pin_human_f, INPUT);
		pinMode(pin_human_l, INPUT);
		pinMode(pin_human_r, INPUT);
		pinMode(pin_human_b, INPUT);
		pullUpDnControl(pin_human_f, PUD_UP);
		pullUpDnControl(pin_human_l, PUD_UP);
		pullUpDnControl(pin_human_r, PUD_UP);
		pullUpDnControl(pin_human_b, PUD_UP);
		
		printf("GPIO opened\n");
		return 0;
	}
}

/*---------------------値の取得----------------------*/

/*方向を返す*/
int human_dir(){
	int human_f, human_l, human_r, human_b;
	int dir, i, count = 0;

	for(i = 0; i < 10; i++){
		human_get(&human_f, &human_l, &human_r, &human_b);
		
		//printf("human_f = %d, human_b = %d\n", human_f, human_b);
        printf("human_r = %d\n", human_r);
        
		/*if(human_f == 1){
			dir = 1;
		}
        else*/
        if(human_r == 0){
			dir = 4;
		}
        else{
			dir = 0;
		}

		if(dir != 0){
			count++;
			if(count >= 3){
                printf("dir = %d\n", dir);
                
				if(warning_flag == 0){
					security_flag = 0;
					warning_flag = 1;
				}
                else{
					human_flag = 1;
				}
				break;
			}
		}
        else{
			human_flag = 0;
		}
        
		usleep(100 * 1000);
	}

	return dir;
}
	

void human_get(int *human_f, int *human_l, int *human_r, int *human_b){
	*human_f = digitalRead(pin_human_f);
	*human_l = digitalRead(pin_human_l);
	*human_r = digitalRead(pin_human_r);
	*human_b = digitalRead(pin_human_b);
}
