#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include "arduino.h"
#include "human.h"
#include "request.h"
#include "uss.h"
#include "flag.h"
#include "run.h"
#include "sensor.h"

int main(){
	/*初期化とスレッドの生成*/
	if(human_init() != 0) return -1;
	if(arduino_open() != 0) return -1;
	if(uss_init() != 0) return -1;

	printf("1\n");
	
	
	flag_init();
	run_init();
	security_flag = 1;
	
	int human_f = 1,human_r = 1,human_l = 1,human_b = 1;

	while(human_r != 0){
		human_get(&human_f, &human_l, &human_r, &human_b);
		usleep(100 * 1000);
	}
	
	printf("2\n");
	pthread_t tid_sensor;
	
	thread_flag = pthread_create( &tid_sensor, NULL, (void  *)sensor, NULL);
	if(thread_flag != 0){
		printf("create error!\n");
		return -1;
	}
	
	usleep(1000 * 1000);


	request_set_led(6);
	request_set_io(OFF);
	request_set_pato(ON);
	
	while(1){
		if(quit_flag == 1){
			printf("quit\n");
			flag_init();
        	run_init();
        	request_set_io(OFF);
        	request_set_pato(OFF);
        	request_set_led(0);
			break;
		}else if(security_flag==1){
			printf("security\n");
			run_security();
		}else if(warning_flag==1){
			printf("warning\n");
			run_warning();
		}else if(avoid_flag==1){
			printf("avoid\n");
			run_avoid();
		}
	}
}
