#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "slack.h"
#include "photograph.h"
#include "kbhit.h"

#define SPD 30

int main(){
    /*Arduinoオープン*/
    if(arduino_open() != 0) return -1;
    
    request_set_led(6);
    request_set_io(OFF);
    request_set_pato(ON);
    request_set_runmode(STP, 0, 0);
    
    int key = 0;
    int count_shot = 0, first_flag = 1;
    
    printf("何かキーを押して下さい\n");
    
    while(1){
        /*キーボード入力待機*/
        if(kbhit()){
            key = getchar();
            printf("%cが押されました\n", key);
            first_flag = 1;
        }
        
        /*動作*/
        if(key != 's'){
            //発射待機カウントリセット
            count_shot = 0;
            
            //プログラム終了
            if(key == 'q'){
                request_set_led(0);
                request_set_io(OFF);
                request_set_pato(OFF);
                request_set_runmode(STP, 0, 0);
                break;
            }
            //前進
            else if(key == 'i'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	request_set_led(6);
                	request_set_io(OFF);
                	request_set_pato(ON);
                	first_flag = 0;
                }
                
                request_set_runmode(STR, SPD, 100);
            }
            //後退
            else if(key == 'k'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	request_set_led(6);
                	request_set_io(OFF);
                	request_set_pato(ON);
                	first_flag = 0;
                }
                
                request_set_runmode(STR, SPD, -100);
            }
            //右旋回
            else if(key == 'l'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	request_set_led(6);
                	request_set_io(OFF);
                	request_set_pato(ON);
                	first_flag = 0;
                }
                
                request_set_runmode(ROT, SPD, -90);
            }
            //左旋回
            else if(key == 'j'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	request_set_led(6);
                	request_set_io(OFF);
                	request_set_pato(ON);
                	first_flag = 0;
                }
                
                request_set_runmode(ROT, SPD, 90);
            }
            //撮影及び送信
            else if(key == 'o'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	request_set_led(6);
                	request_set_io(OFF);
                	request_set_pato(ON);
                	first_flag = 0;
                }
                
                photograph();
                slack_img();
                usleep(3000 * 1000);
            }
            //警戒表示
            else if(key == 'w'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
                	slack_txt(0);
                	first_flag = 0;
                }
                
                request_set_led(1);
                usleep(1000 * 1000);
                request_set_io(ON);
                request_set_pato(ON);
            }
            //転倒表示
            else if(key == 'e'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
            		request_set_io(OFF);
                	request_set_pato(OFF);
                	slack_txt(1);
                	first_flag = 0;
                }
                
            	request_set_led(3);
                usleep(1000 * 1000);
            }
            //バッテリー切れ表示
            else if(key == 'd'){
            	if(first_flag == 1){
            		request_set_runmode(STP, 0, 0);
            		request_set_io(OFF);
                	request_set_pato(OFF);
                	slack_txt(2);
                	first_flag = 0;
                }
                
            	request_set_led(4);
                usleep(1000 * 1000);
            }
            //イルミネーション
            else if(key == 'r'){
            	if(first_flag == 1){
		        	request_set_runmode(STP, 0, 0);
		        	request_set_io(OFF);
		            request_set_pato(ON);
		            first_flag = 0;
		        }
		        
            	request_set_led(5);
                usleep(9000 * 1000);
            }
            //全停止
            else{
            	if(first_flag == 1){
            		printf("stop\n");
            		first_flag = 0;
		        }
		        
		        request_set_runmode(STP, 0, 0);
                request_set_led(0);
                request_set_io(OFF);
                request_set_pato(OFF);
            }
        }
        //発射
        else{
        	if(first_flag == 1){
		        	request_set_runmode(STP, 0, 0);
		            first_flag = 0;
		    }
		    
            count_shot++;
            request_set_led(2);
            usleep(1000 * 1000);
            request_set_io(ON);
            request_set_pato(ON);
            
            //5秒間待機後発射
            if(count_shot >= 3){
                request_set_shot();
                printf("霊丸!!!!!!!!!!!!!!!!!!!!!!!\n");
                count_shot = 0;
            }
        }
        
        //1秒サイクル
        usleep(1000 * 1000);
    }
    
    return 0;
}
