#include <stdio.h>
#include <unistd.h>
#include "request.h"
#include "uss.h"
#include "flag.h"
#include "sensor.h"
#include "run.h"
#include "human.h"
#include "slack.h"
#include "photograph.h"

/*超音波センサの位置*/
#define f 	1	/*前方,正転*/
#define fr 	2	/*前方右斜め*/
#define r 	3	/*右*/
#define b 	4	/*後方,逆転*/
#define l 	5	/*左*/
#define fl 	6	/*前方左斜め*/
#define br 	7	/*後方右斜め*/
#define bl 	8	/*後方左斜め*/
#define DIF	1 + 0.5 / 90	/*回転目標値との差*/

long uss_f, uss_fr, uss_fl, uss_r, uss_l, uss_b;
int run_way = 0;
int run_count = 0;
int run_count_detect = 0; 
int warning_first_flag = 1;
int humanDir = 0;
int rotation = 0;

void run_init(){
	run_way = 1;
	request_set_runmode(STP,0,0);
}

void run_security(){
	
	/*D科lab前*/	
	if(run_way == 1){
		printf("run_way = 1\n");
		
		request_set_runmode(STR, 30, 30);
		usleep(500 * 1000);
		
		run_count++;
		
		uss_f = uss_get(f);
		uss_r = uss_get(r);

		if((uss_r == -1 || uss_r > 200) && uss_f < 70){
				run_way = 2;
				run_flag = 1;
				run_count_detect = 0;
		}
	}
	
	/*保健室前*/
	if(run_way == 2){
		printf("run_way=2\n");
		
		if(run_flag == 1){
			request_set_runmode(ROT, 50, -90 * DIF);
			usleep( 2200 * 1000);
			run_flag = 0;
		}
		
		request_set_runmode(STR, 30, 30);
		usleep(500 * 1000);
		
		run_count++;
		
		uss_f = uss_get(f);
		
        	if(uss_f < 70){
           		run_way = 3;
        		run_flag = 1;
           		run_count_detect = 0;
        	}	
        
	}

	if(run_way == 3){
		printf("run_way=3\n");
		
		if(run_flag == 1){
			request_set_runmode(ROT, 50, 180 * DIF);
			usleep(4400*1000);
			run_flag = 0;
		}
		
		request_set_runmode(STR,30,30);
		usleep(500 * 1000);
		
		run_count++;
		
		uss_f = uss_get(f);
		uss_l = uss_get(l);
		
		if((uss_l == -1 || uss_l > 200) && uss_f < 100){
			run_way = 4;
			run_flag = 1;
			run_count_detect = 0;
		}
	}
	
	if(run_way == 4){
		printf("run_way=4\n");
		
		if(run_flag == 1){
			request_set_runmode(ROT, 50, 90 * DIF);
			usleep(2200*1000);
			run_flag = 0;
		}
		
		request_set_runmode(STR, 30, 30);
		usleep(500 * 1000);
		
		run_count++;
		
		if(run_count_detect >= 2){
			run_way = 0;
			quit_flag = 1;
		}
	}
	
	if(run_count >= 50){
		request_set_runmode(STP, 0, 0);
		photograph();
		slack_img();
		usleep(2000 * 1000);
		run_count = 0;
		run_count_detect++;
		humanDir = human_dir();
	}
}

void run_warning(){
	request_set_led(1);
	usleep(50 * 1000);

	slack_txt(0);
	request_set_io(ON);
	request_set_pato(ON);

	if(human_flag == 0){
		run_human(humanDir,f);
		rotation = humanDir;
	}
	
	photograph();
	slack_img();
	usleep(2000 * 1000);
	humanDir = human_dir();
	
	if(human_flag == 1 && warning_first_flag == 1){
		request_set_led(2);
		usleep(50 * 1000);
		request_set_shot();
		printf("霊丸!!!!!!!!!!!!!!!!!!!!!!!!!\n");
		warning_first_flag = 0;
	}
	else if(human_flag == 1){
		request_set_led(1);
		usleep(50 * 1000);
	}
	else{
		avoid_flag = 0;
		warning_flag=0;
		security_flag=1;
		request_set_led(6);
		usleep(50 * 1000);
		request_set_io(OFF);
		run_human(rotation,b);
		rotation=0;
	}
	
	
}

void run_avoid(){
	/*障害物発見後*/
	request_set_runmode(STP,0,0);
	if(uss_dir == f){
		request_set_runmode(STR,30,-30);
		usleep(1000 * 1000);
	}
	else if(uss_dir == fr){
		request_set_runmode(ROT,50,-45*DIF);
		usleep(1300*1000);
		request_set_runmode(STR,30,-45);
		usleep(1500*1000);
		request_set_runmode(ROT,50,45*DIF);
		usleep(1300*1000);
	}
	else if(uss_dir == fl){
		request_set_runmode(ROT,50,45*DIF);
        	usleep(1300*1000);
        	request_set_runmode(STR,30,-45);
        	usleep(1500*1000);
        	request_set_runmode(ROT,50,-45*DIF);
        	usleep(1300*1000);
	}
	
	avoid_flag=0;
	security_flag=1;
}

void run_human(int humanDir,int rot){
	if(rot == f){
		if(humanDir == f){
		}else if(humanDir == b){
			request_set_runmode(ROT,50,180*DIF);
			usleep(4400*1000);
		}
	}else if(rot == b){
		if(humanDir == f){
        	}else if(humanDir == b){
              		request_set_runmode(ROT,50,180*DIF);
                	usleep(4400*1000);
        	}
	}else{
		printf("human_rot error!!!!!!!!!");
	}
}
