#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "kbhit.h"

int main(){
    /*Arduinoオープン*/
    if(arduino_open() != 0) return -1;

    request_set_runmode(STP, 0, 0);
    
    int key = 0;
    
    printf("何かキーを押して下さい\n");
    
    while(1){
        /*キーボード入力待機*/
        if(kbhit()){
            key = getchar();
            printf("%cが押されました\n", key);
        }
        
        /*動作*/
        //プログラム終了
        if(key == 'q'){
            request_set_runmode(STP, 0, 0);
            break;
        }
        //前進
        else if(key == 'w'){
            request_set_runmode(STR, 30, 100);
        }
        //後退
        else if(key == 's'){
            request_set_runmode(STR, 30, -100);
        }
        //右旋回
        else if(key == 'd'){
            request_set_runmode(ROT, 50, -90);
        }
        //左旋回
        else if(key == 'a'){
            request_set_runmode(ROT, 50, 90);
        }
        //停止
        else{
			request_set_runmode(STP, 0, 0);
        }
        
        //1秒サイクル
        usleep(1000 * 1000);
    }
    
    return 0;
}
