#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "uss.h"

int main(){
	int mode, speed, dist;
	double volt;
	char buf[256];
	run_state_t state;
	
	if(arduino_open() != 0) return -1;
	
	while(1){
		printf("0:stop 1:straight 2:rotate 3:get_mode 4:get_volt 5:vel 6:io 7:shot\n");
		fgets(buf, sizeof(buf), stdin);
		sscanf(buf, "%d", &mode);
		
		switch(mode){
		case 0:
			request_set_runmode(STP, 0, 0);
			break;
		case 1:
			printf("speed? [cm/s]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &speed);
			
			printf("dist? [cm]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &dist);
			
			request_set_runmode(STR, speed, dist);
			break;
		case 2:
			printf("speed? [deg/s]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &speed);
			
			printf("angle? [deg]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &dist);
			
			request_set_runmode(ROT, speed, dist);
			break;
		case 3:
			request_get_runmode(&state, &speed, &dist);
			printf("state = %s\n",((state == STR) ? "STR" : (state == ROT) ? "ROT" : "STP"));
			break;
		case 4:
			request_get_batt(&volt);
			printf("batt = %4.2lf\n", volt);
			break;
		case 5:
			printf("speed_l? [cm/s]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &speed);
			
			printf("speed_r? [cm/s]\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &dist);
			
			request_set_runmode(VEL, speed, dist);
			break;
		case 6:
			printf("ok\n");
			request_set_io(ON);
			usleep(3000 * 1000);
			request_set_io(OFF);
			break;
		case 7:
			request_set_shot();
			break;
		}
	}
	
	arduino_close();
	return 0;
}
